<DATE>  Alexandre Oliva  <oliva@dcc.unicamp.br>

	* config/sparc/common.h: (sysdepCallMethod) handle float and
	double return values
	* config/sparc/jit-sparc.def: (build_key) add missing
	semicolon, for debugging

Index: config/sparc/common.h
===================================================================
RCS file: /home/msc/oliva/src/.cvs/kaffe/config/sparc/common.h,v
retrieving revision 1.1.1.2
diff -u -r1.1.1.2 common.h
--- common.h	1998/05/01 00:55:21	1.1.1.2
+++ common.h	1998/05/03 22:58:53
@@ -22,6 +22,9 @@
     register int o3 asm("o3");						\
     register int o4 asm("o4");						\
     register int o5 asm("o5");						\
+    register double f0d asm("f0");					\
+    register float f0f asm("f0");					\
+    int *res;								\
   default:								\
     {									\
       int *args = extraargs-1;						\
@@ -68,12 +71,21 @@
 	  "0" (o0), "1" (o1), "r" (o2), "r" (o3), "r" (o4), "r" (o5)	\
 	: "g1", "g2", "g3", "g4", "o7", "cc"				\
 	);								\
+    res = &(CALL)->ret->i;						\
     switch((CALL)->retsize) {						\
     case 2:								\
-      (CALL)->ret->j = (((long long)o0) << 32) | o1;			\
+      if ((CALL)->rettype == 'D')					\
+        *(double*)res = f0d;						\
+      else {								\
+        res[1] = o1;							\
+        res[0] = o0;							\
+      }									\
       break;								\
     case 1:								\
-      (CALL)->ret->i = o0;						\
+      if ((CALL)->rettype == 'F')					\
+        *(float*)res = f0f;						\
+      else								\
+        *res = o0;							\
       break;								\
     case 0:								\
       break;								\
Index: config/sparc/jit-sparc.def
===================================================================
RCS file: /home/msc/oliva/src/.cvs/kaffe/config/sparc/jit-sparc.def,v
retrieving revision 1.1.1.5
diff -u -r1.1.1.5 jit-sparc.def
--- jit-sparc.def	1998/03/30 23:10:53	1.1.1.5
+++ jit-sparc.def	1998/05/03 22:50:01
@@ -850,7 +850,7 @@
 {
 	jint val = const_int(2);
 
-	LOUT = val
+	LOUT = val;
 
 	debug((".word %08x\n", val));
 }
@@ -1139,7 +1139,17 @@
 		insn_RRR(2, REG_i0, r1, REG_g0);
 	}
 	else {
-		abort();
+		/* swap i0 <-> i1 */
+
+		insn_RRR(3, r1, r1, r2);
+
+		debug(("xor %s,%s,%s\n", regname(r1), regname(r2), regname(r1)));
+		insn_RRR(3, r2, r1, r2);
+
+		debug(("xor %s,%s,%s\n", regname(r1), regname(r2), regname(r2)));
+		insn_RRR(3, r1, r1, r2);
+
+		debug(("xor %s,%s,%s\n", regname(r1), regname(r2), regname(r1)));
 	}
 }
 
